//
// Created by webpigeon on 29/12/22.
//

#include "labs/sorting/lab1.hpp"

#include <algorithm>
#include <random>

std::vector<unsigned int> generate_list(unsigned int n, bool shuffle, bool reverse) {
    std::vector<unsigned int> myList;
    myList.reserve(n);
    for (auto i=0u; i<n; ++i) {
        myList.push_back(i);
    }

    // if shuffle is requested, shuffle list
    if (shuffle) {
        std::shuffle(myList.begin(), myList.end(), std::mt19937(std::random_device()()));
    }

    // if reverse is requested, reverse list
    if (reverse) {
        std::reverse(myList.begin(), myList.end());
    }

    return myList;
}

// same idea as std::swap but slightly easier interface
static void lab_swap(std::vector<unsigned int>& inputs, unsigned int idx1, unsigned int idx2) {
    auto val = inputs[idx1];
    inputs[idx1] = inputs[idx2];
    inputs[idx2] = val;
}

// used for part 2
[[maybe_unused]]
void partial_shuffle(std::vector<unsigned int>& input, unsigned int swaps) {

    std::default_random_engine rnd;
    std::uniform_int_distribution<unsigned int> dist(0u, input.size());

    for (int i=0; i<swaps; ++i) {
        auto idx1 = dist( rnd );
        auto idx2 = dist( rnd );
        lab_swap(input, idx1, idx2);
    }
}

void bubble_sort(std::vector<unsigned int>& inputs) {
    // TODO write bubble sort here
}

#ifdef JWR_PART_2
#include "lab1_part2.cpp"
#endif